/* based on DJGPP mktemp() */
#include <stddef.h>
#include <msdos/fcntl.h>

int file_exists(char *name) {
  char dta[64];
  int result;

  result = __dos_stat(name, &dta[0]);
  if (result == 0) {
     return 1;
  }
  return 0;
}

char *
mktemp(char *_template)
{
  int i, len, xcount;
  int count = 0;

  for (i = 0; _template[i]; i++);
  for (xcount = 0, len = i; xcount < 6  && _template[--i] == 'X'; xcount++);

  if (xcount) {
    char *cp, *dp;
    int loopcnt;

    dp = cp = _template + i;

    while (dp > _template && 
      dp[-1] != '/' &&
      dp[-1] != '\\' &&
      dp[-1] != ':'
    ) {
      dp--;
    }

    /* Keep the first characters of the template, but turn the rest into Xs. */
    while (cp > dp + 8 - xcount) {
      *--cp = 'X';
      xcount = (xcount >= 6) ? 6 : 1 + xcount;
    }

    /* If dots occur too early -- squash them.  */
    while (dp < cp) {
      if (*dp == '.') {
        *dp = 'a';
      }
      dp++;
    }

    /* Try to add ".tmp" to the filename.  Truncate unused Xs.  */
    if (cp + xcount + 3 < _template + len) {
      strcpy (cp + xcount, ".tmp");
    } else {
      cp[xcount] = 0;
    }

    for (loopcnt = 0; loopcnt < (1 << (2 * xcount)); loopcnt++) {
      int c = count++;
      for (i = 0; i < xcount; i++, c >>= 5) {
        cp[i] = "abcdefghijklmnopqrstuvwxyz012345"[c & 0x1f];
      }
      if (!file_exists(_template)) {
        return _template;
      }
    }
  }

  /* Failure:  truncate the template and return NULL.  */
  *_template = 0;
  return NULL;
}

int mkstemp(char *_template) {
  char *fn;
  int fd = -1;

  fn = mktemp(_template);
  if (fn != NULL) {
      fd = open(fn, O_CREAT|O_EXCL|O_RDWR);
  }
  return fd;
}
