#include <stddef.h>
#include <tiny-re/compat.h>

/* 0 success, REG_NOMATCH failure */

int tiny_regexec(regex_t *preg, char *string, size_t nmatch,
    regmatch_t *pmatch, int eflags)
{
    int offset, length, retval;
    char *str, *endptr, c;
    if (eflags == REG_STARTEND && pmatch != NULL) {
        str = &string[pmatch[0].rm_so];
        endptr = &string[pmatch[0].rm_eo];
        c = endptr[0];
        endptr[0] = 0;
        offset = re_matchp(preg, str, &length);
        endptr[0] = c;
    } else {
        str = string;
        offset = re_matchp(preg, str, &length);
    }
    if (offset == -1) {
        retval = REG_NOMATCH;
    } else {
        retval = 0;
        if (pmatch != NULL) {
            if (eflags != REG_STARTEND) {
                pmatch->rm_so = 0;
            }
	    pmatch->rm_so += offset;
	    pmatch->rm_eo = pmatch->rm_so + length;
        }
    }
    return retval;
}
